/* add your code here */

//#include <sys/systm.h>
//#include <mach/mach_types.h>

#include <IOKit/IOLib.h>
#include <IOKit/IOService.h>
#include <IOKit/storage/IODVDMedia.h>

#include "Blarg.h"

extern "C" {
#include <pexpert/pexpert.h>
}

#define super IOService
OSDefineMetaClassAndStructors( Blarg_IOKit, IOService )

bool Blarg_IOKit::init( OSDictionary *dict = 0 )
{
    bool res = super::init( dict );
    IOLog( "Blarg initializing\n" );
    return res;
}
    
void Blarg_IOKit::free( void )
{
    IOLog( "Blarg freeing\n" );
    super::free( );
}


IOService * Blarg_IOKit::probe( IOService *provider, SInt32 *score )
{
    IOService * res = super::probe( provider, score );
    IOLog( "Blarg probing\n" );
    return res;
}


bool Blarg_IOKit::start( IOService *provider )
{
    bool res = super::start( provider );
    IOLog( "Blarg starting\n" );
    return res;
}


void Blarg_IOKit::stop( IOService *provider )
{
    IOLog( "Blarg stopping\n" );
    super::stop( provider );
}
  
IOReturn Blarg_IOKit::report( IODVDMedia *DVD, IOMemoryDescriptor *buffer, const DVDKeyClass keyClass, const UInt32 lba, const UInt8 agid, const DVDKeyFormat keyFormat )
{
    IOLog( "Blarg reportkey\n" );
    return DVD->getProvider()->reportKey( buffer, keyClass, lba, agid, keyFormat );
}

IOReturn Blarg_IOKit::send( IODVDMedia *DVD, IOMemoryDescriptor *buffer, const DVDKeyClass keyClass, const UInt32 lba, const DVDKeyFormat keyFormat )
{
    IOLog( "Blarg sendkey\n" );
    return DVD->getProvider()->sendKey( buffer, keyClass, lba, keyFormat );
}
